// AlgorithmList.cpp : implementation file
//

#include "stdafx.h"
#include "VGK.h"
#include "AlgorithmList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const BORD = 5;
const BYTE AlgoBlock[] = {
	46, // 1 -
	46, // 2 
	63, // 3 
	73, // 4  1
	92, // 5  2
};

const WIDTH_BLOCK = 179; //  
const SPACE_BLOCK =  30; //    

const BYTE AlgoData[][2] = {
	AlgoBlock[0], 1, //  1
	AlgoBlock[1], 2, //  2
	46,           0, //  3
	46,           0, //  4
	46,           0, //  5
	55,           0, //  6
	AlgoBlock[3], 4, //  7
	46,           0, //  8
	46,           0, //  9
	AlgoBlock[3], 4, // 10
	AlgoBlock[2], 3, // 11
	46,           0, // 12
	46,           0, // 13
	AlgoBlock[4], 5, // 14
	AlgoBlock[3], 4, // 15
	46,           0, // 16
	46,           0, // 17
	AlgoBlock[3], 4, // 18
	46,           0, // 19
	46,           0, // 20
	46,           0, // 21
	AlgoBlock[3], 4, // 22
	57,           0, // 23
	AlgoBlock[3], 4, // 24
	AlgoBlock[4], 5, // 25
	46,           0, // 26
	46,           0, // 27
	46,           0, // 28
	73,           0, // 29
	AlgoBlock[3], 4, // 30
	AlgoBlock[3], 4, // 31
	56,           0, // 32
	56,           0, // 33
	AlgoBlock[3], 4, // 34
	56,           0, // 35
	56,           0, // 36
	AlgoBlock[3], 4, // 37
	49,           0, // 38
	56,           0, // 39
	56,           0, // 40
	AlgoBlock[3], 4, // 41
	AlgoBlock[3], 4, // 42
	46,           0, // 43
	46,           0, // 44
	46,           0, // 45
	46,           0, // 46
	96,           0, // 47
	46,           0, // 48
	AlgoBlock[3], 4, // 49
	77,           0, // 50
	46,           0, // 51
	AlgoBlock[3], 4, // 52
	61,           0, // 53
	46,           0, // 54
	AlgoBlock[3], 4, // 55
	AlgoBlock[0], 1
};

/////////////////////////////////////////////////////////////////////////////
// CAlgorithmList

CAlgorithmList::CAlgorithmList()
{
	m_bmpAlgoData = new CBitmap;
	if (m_bmpAlgoData != NULL)
		m_bmpAlgoData->LoadBitmap(IDB_ALGODATA);
	m_bmpAlgoBlock = new CBitmap;
	if (m_bmpAlgoBlock != NULL)
		m_bmpAlgoBlock->LoadBitmap(IDB_ALGOBLOCK);
	m_memDCBlock = new CDC;
	m_memDCData = new CDC;
}

CAlgorithmList::~CAlgorithmList()
{
	if (m_bmpAlgoData != NULL) {
		m_bmpAlgoData->DeleteObject();
		delete m_bmpAlgoData;
	}
	if (m_bmpAlgoBlock != NULL) {
		m_bmpAlgoBlock->DeleteObject();
		delete m_bmpAlgoBlock;
	}
	if (m_memDCBlock != NULL) delete m_memDCBlock;
	if (m_memDCData != NULL) delete m_memDCData;
	DestroyWindow();
}

BOOL CAlgorithmList::Create(CDialogBar* pParentWnd, UINT nID)
{
	pParentWnd->m_sizeDefault.cx = BORD*2+WIDTH_BLOCK+SPACE_BLOCK*2;
	CRect rect(CPoint(BORD,BORD),pParentWnd->m_sizeDefault);
	rect.right  -= 2*BORD;
	rect.bottom -= 2*BORD;

	BOOL bSuccess = CListBox::Create( LBS_NOTIFY|LBS_OWNERDRAWVARIABLE|
		WS_CHILD | WS_VISIBLE | WS_VSCROLL,
		rect,
		pParentWnd,
		nID );
	if (!bSuccess) return FALSE;
	SetFont(pParentWnd->GetFont());
	ModifyStyleEx(0,WS_EX_CLIENTEDGE,SWP_NOZORDER);
	SetWindowPos(NULL,rect.left,rect.top,rect.Width(),rect.Height(),SWP_NOZORDER);
	//     
	for (int i=0; i<sizeof(AlgoData)/sizeof(BYTE)/2; i++)
		AddString("");
	SetCurSel( 0 );
	//         
	if (m_memDCBlock->CreateCompatibleDC(GetDC()))
		m_memDCBlock->SelectObject(m_bmpAlgoBlock);
	if (m_memDCData->CreateCompatibleDC(GetDC()))
		m_memDCData->SelectObject(m_bmpAlgoData);
	
	return bSuccess;
}

BEGIN_MESSAGE_MAP(CAlgorithmList, CListBox)
	//{{AFX_MSG_MAP(CAlgorithmList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAlgorithmList message handlers


void CAlgorithmList::MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct) 
{
	// TODO: Add your code to determine the size of specified item
	lpMeasureItemStruct->itemHeight = AlgoData[lpMeasureItemStruct->itemID][0]+SPACE_BLOCK;
}

void CAlgorithmList::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	// TODO: Add your code to draw the specified item
	CDC dc;
	dc.Attach(lpDrawItemStruct->hDC);
	if (lpDrawItemStruct->itemAction & (ODA_DRAWENTIRE|ODA_SELECT))
	{
		COLORREF color;
		CPen pen;
		pen.CreatePen(PS_SOLID|PS_GEOMETRIC,2,RGB(0,0,0));
		dc.SelectObject(&pen);
		if (lpDrawItemStruct->itemState & ODS_SELECTED)
			color = RGB(200,200,200);
		else
			color = RGB(255,255,255);
		dc.FillSolidRect(&lpDrawItemStruct->rcItem,color);
		dc.MoveTo((SPACE_BLOCK+WIDTH_BLOCK)/2,lpDrawItemStruct->rcItem.top+
			((lpDrawItemStruct->itemID == 0) ? SPACE_BLOCK/2+1 : 0)+
			((lpDrawItemStruct->itemID == 12) ? SPACE_BLOCK/4+1 : 0));
		dc.LineTo((SPACE_BLOCK+WIDTH_BLOCK)/2,lpDrawItemStruct->rcItem.bottom-
			((lpDrawItemStruct->itemID == sizeof(AlgoData)/sizeof(BYTE)/2-1) ? SPACE_BLOCK/2+1 : 0)-
			((lpDrawItemStruct->itemID == 11) ? SPACE_BLOCK/4+1 : 0));
		CRect r = lpDrawItemStruct->rcItem;
		r.left   += SPACE_BLOCK/2;
		r.top    += SPACE_BLOCK/2;
		r.right   = SPACE_BLOCK/2+WIDTH_BLOCK;
		r.bottom -= SPACE_BLOCK/2;
		if (AlgoData[lpDrawItemStruct->itemID][1]!=0)
		{
			dc.BitBlt(r.left,r.top,WIDTH_BLOCK,AlgoData[lpDrawItemStruct->itemID][0],
				m_memDCBlock, 0, GetPosAlgoBlock(AlgoData[lpDrawItemStruct->itemID][1]-1),SRCCOPY);
		}
		else dc.Rectangle(&r);
		dc.BitBlt(r.left,r.top,WIDTH_BLOCK,AlgoData[lpDrawItemStruct->itemID][0],
			m_memDCData, 0, GetPosAlgoData(lpDrawItemStruct->itemID),SRCAND);

		switch (lpDrawItemStruct->itemID) {
			case 10:
				dc.TextOut(r.right+1,r.top + r.Height()/2-dc.GetTextExtent("").cy-2,"");
				dc.TextOut(r.left+WIDTH_BLOCK/2+3, r.bottom+1 ,"");
				dc.MoveTo(r.right,r.top + r.Height()/2);
				dc.LineTo(r.right+SPACE_BLOCK/3,r.top + r.Height()/2);
				dc.LineTo(r.right+SPACE_BLOCK/3,lpDrawItemStruct->rcItem.bottom);
				break;
			case 11:
				dc.MoveTo(r.right+SPACE_BLOCK/3,lpDrawItemStruct->rcItem.top);
				dc.LineTo(r.right+SPACE_BLOCK/3,lpDrawItemStruct->rcItem.bottom);
				dc.MoveTo(r.left+WIDTH_BLOCK/2,r.bottom+SPACE_BLOCK/4);
				dc.LineTo(SPACE_BLOCK/6,r.bottom+SPACE_BLOCK/4);
				dc.LineTo(SPACE_BLOCK/6,lpDrawItemStruct->rcItem.bottom);
				break;
			case 12:
				dc.MoveTo(SPACE_BLOCK/6,lpDrawItemStruct->rcItem.top);
				dc.LineTo(SPACE_BLOCK/6,lpDrawItemStruct->rcItem.bottom-SPACE_BLOCK/4);
				dc.LineTo(r.left+WIDTH_BLOCK/2,lpDrawItemStruct->rcItem.bottom-SPACE_BLOCK/4);
				dc.MoveTo(r.right+SPACE_BLOCK/3,lpDrawItemStruct->rcItem.top);
				dc.LineTo(r.right+SPACE_BLOCK/3,lpDrawItemStruct->rcItem.top+SPACE_BLOCK/4);
				dc.LineTo(r.left+WIDTH_BLOCK/2,lpDrawItemStruct->rcItem.top+SPACE_BLOCK/4);
				break;
		}

		CString str;
		str.Format(" %d ",lpDrawItemStruct->itemID+1);
		dc.TextOut(r.left+10,r.top-dc.GetTextExtent(str).cy/2+((AlgoData[lpDrawItemStruct->itemID][1] == 3) ? 24 : 0)-2,str);
		dc.SelectStockObject(BLACK_PEN);
		pen.DeleteObject();

		if (lpDrawItemStruct->itemState & ODS_FOCUS)
			dc.DrawFocusRect(&lpDrawItemStruct->rcItem);
	}
	else if (lpDrawItemStruct->itemAction & ODA_FOCUS)
			dc.DrawFocusRect(&lpDrawItemStruct->rcItem);
}

int CAlgorithmList::GetPosAlgoBlock(int index)
{
	if (index>(sizeof(AlgoBlock)/sizeof(BYTE)-1))
		index = sizeof(AlgoBlock)/sizeof(BYTE)-1;
	int Pos = 0;
	for (int i=1; i<=index; i++) Pos += AlgoBlock[i-1];
	return Pos;
}

int CAlgorithmList::GetPosAlgoData(int index)
{
	if (index>(sizeof(AlgoData)/sizeof(BYTE)/2-1))
		index = sizeof(AlgoData)/sizeof(BYTE)/2-1;
	int Pos = 0;
	for (int i=1; i<=index; i++) Pos += AlgoData[i-1][0];
	return Pos;
}


void CAlgorithmList::Resize(CSize* s)
{
	SetWindowPos(NULL,BORD,BORD,s->cx-2*BORD,s->cy-2*BORD,SWP_NOZORDER);
}

