// InputData.cpp : implementation file
//

#include "stdafx.h"
#include "VGK.h"
#include "MainFrm.h"
//#include "InputData.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CInputData dialog

CInputData::CInputData()
	: CDialog()
{
	//{{AFX_DATA_INIT(CInputData)
	m_L = 0.0f;
	m_Nmax = 0.0f;
	m_Nmin = 0.0f;
	m_Q = 0.0f;
	m_T = 0.0f;
	m_I = 0;
	m_D0 = 0.0f;
	m_R2 = 0.0f;
	m_Lambda = 0.0f;
	//}}AFX_DATA_INIT
}

CInputData::~CInputData()
{
	DestroyWindow();
}

void CInputData::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	if (pDX->m_bSaveAndValidate == FALSE)
	{
		switch (L_Dim)
		{
			case 1: m_L = m_L/1000; break; //   
			case 2: m_L = m_L/100; break;  //   
		}
		switch (Q_Dim)
		{
			case 1: m_Q = m_Q/1000; break; //   
			case 2: m_Q = m_Q/9.81f; break; //   
		}
	}
	//{{AFX_DATA_MAP(CInputData)
	DDX_Text(pDX, IDC_EDITL, m_L);
	DDX_Text(pDX, IDC_EDITNMAX, m_Nmax);
	DDX_Text(pDX, IDC_EDITNMIN, m_Nmin);
	DDX_Text(pDX, IDC_EDITQ, m_Q);
	DDX_Text(pDX, IDC_EDITT, m_T);
	DDX_Text(pDX, IDC_EDITI, m_I);
	DDV_MinMaxInt(pDX, m_I, 0, 100);
	DDX_Text(pDX, IDC_EDITD0, m_D0);
	DDX_Text(pDX, IDC_EDITLAMBDA, m_Lambda);
	DDX_Text(pDX, IDC_EDITR2, m_R2);
	DDX_CBIndex(pDX, IDC_COMBOL, L_Dim);
	DDX_CBIndex(pDX, IDC_COMBOQ, Q_Dim);
	//}}AFX_DATA_MAP
	if (pDX->m_bSaveAndValidate == TRUE)
	{
		switch (L_Dim)
		{
			case 1: m_L = m_L*1000; break; //   
			case 2: m_L = m_L*100; break;  //   
		}
		switch (Q_Dim)
		{
			case 1: m_Q = m_Q*1000; break; //   
			case 2: m_Q = m_Q*9.81f; break; //   
		}
	}
}


BEGIN_MESSAGE_MAP(CInputData, CDialog)
	//{{AFX_MSG_MAP(CInputData)
	ON_CBN_SELCHANGE(IDC_COMBOL, OnSelchangeComboL)
	ON_CBN_SELCHANGE(IDC_COMBOQ, OnSelchangeComboQ)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINI, OnDeltaposSpinI)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINL, OnDeltaposSpinL)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINNMAX, OnDeltaposSpinNmax)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINNMIN, OnDeltaposSpinNmin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINQ, OnDeltaposSpinQ)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINT, OnDeltaposSpinT)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIND0, OnDeltaposSpinD0)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINR2, OnDeltaposSpinR2)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINLAMBDA, OnDeltaposSpinLambda)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInputData message handlers

BOOL CInputData::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	CenterWindow();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

//////////////////////////////////////////////////////////////////////
// ComboBox Selchange

void CInputData::OnSelchangeComboL() 
{
	// TODO: Add your control notification handler code here
	PrevDlgCtrl( );
}

void CInputData::OnSelchangeComboQ() 
{
	// TODO: Add your control notification handler code here
	PrevDlgCtrl( );
}

//////////////////////////////////////////////////////////////////////
// Spin Deltapos

void CInputData::OnDeltaposSpinL(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	float L;
	CDataExchange DX(this, TRUE);
	DDX_Text(&DX, IDC_EDITL, L);
	CComboBox* cb = (CComboBox*) GetDlgItem(IDC_COMBOL);
	int CurSel = cb->GetCurSel();
	float Delta;
	switch (CurSel)
	{
		case 0: Delta = 50.0f; break;
		case 1: Delta = 0.05f; break;
		case 2: Delta = 5.0f; break;
	}
	if (pNMUpDown->iDelta<0)
		L = L + Delta;
	else
	{
		L = L - Delta;
		if (L < 0) L = 0.0f;
	}
	DX.m_bSaveAndValidate = FALSE;
	DDX_Text(&DX, IDC_EDITL, L);
	*pResult = 0;
}

void CInputData::OnDeltaposSpinT(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	float T;
	CDataExchange DX(this, TRUE);
	DDX_Text(&DX, IDC_EDITT, T);
	if (pNMUpDown->iDelta<0)
		T = T + 1;
	else
	{
		T = T - 1;
		if (T < 0) T = 0.0f;
	}
	DX.m_bSaveAndValidate = FALSE;
	DDX_Text(&DX, IDC_EDITT, T);
	*pResult = 0;
}

void CInputData::OnDeltaposSpinQ(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	float Q;
	CDataExchange DX(this, TRUE);
	DDX_Text(&DX, IDC_EDITQ, Q);
	CComboBox* cb = (CComboBox*) GetDlgItem(IDC_COMBOQ);
	int CurSel = cb->GetCurSel();
	float Delta;
	switch (CurSel)
	{
		case 0: Delta = 500.0f; break;
		case 1: Delta = 0.5f; break;
		case 2: Delta = 50.0f; break;
	}
	if (pNMUpDown->iDelta<0)
		Q = Q + Delta;
	else
	{
		Q = Q - Delta;
		if (Q < 0) Q = 0.0f;
	}
	DX.m_bSaveAndValidate = FALSE;
	DDX_Text(&DX, IDC_EDITQ, Q);
	*pResult = 0;
}

void CInputData::OnDeltaposSpinNmax(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	float NMax;
	CDataExchange DX(this, TRUE);
	DDX_Text(&DX, IDC_EDITNMAX, NMax);
	if (pNMUpDown->iDelta<0)
		NMax = NMax + 10;
	else
	{
		NMax = NMax - 10;
		if (NMax < 0) NMax = 0.0f;
	}
	DX.m_bSaveAndValidate = FALSE;
	DDX_Text(&DX, IDC_EDITNMAX, NMax);
	*pResult = 0;
}

void CInputData::OnDeltaposSpinNmin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	float NMin;
	CDataExchange DX(this, TRUE);
	DDX_Text(&DX, IDC_EDITNMIN, NMin);
	if (pNMUpDown->iDelta<0)
		NMin = NMin + 1;
	else
	{
		NMin = NMin - 1;
		if (NMin < 0) NMin = 0.0f;
	}
	DX.m_bSaveAndValidate = FALSE;
	DDX_Text(&DX, IDC_EDITNMIN, NMin);
	*pResult = 0;
}

void CInputData::OnDeltaposSpinI(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	int I;
	CDataExchange DX(this, TRUE);
	DDX_Text(&DX, IDC_EDITI, I);
	if (pNMUpDown->iDelta<0)
		if ((I + 1)<100) I = I + 1;
	else
		if ((I - 1) > 0) I = I - 1;
	DX.m_bSaveAndValidate = FALSE;
	DDX_Text(&DX, IDC_EDITI, I);
	*pResult = 0;
}

void CInputData::OnDeltaposSpinD0(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	float D0;
	CDataExchange DX(this, TRUE);
	DDX_Text(&DX, IDC_EDITD0, D0);
	if (pNMUpDown->iDelta<0)
		D0 += 1.0f;
	else
	{
		D0 -= 1.0f;
		if (D0<0.0f) D0 = 0.0f;
	}
	DX.m_bSaveAndValidate = FALSE;
	DDX_Text(&DX, IDC_EDITD0, D0);
	*pResult = 0;
}

void CInputData::OnDeltaposSpinR2(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	float R2;
	CDataExchange DX(this, TRUE);
	DDX_Text(&DX, IDC_EDITR2, R2);
	if (pNMUpDown->iDelta<0)
		R2 += 0.1f;
	else
	{
		R2 -= 0.1f;
		if (R2<0.0f) R2 = 0.0f;
	}
	DX.m_bSaveAndValidate = FALSE;
	DDX_Text(&DX, IDC_EDITR2, R2);
	*pResult = 0;
}

void CInputData::OnDeltaposSpinLambda(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	float Lambda;
	CDataExchange DX(this, TRUE);
	DDX_Text(&DX, IDC_EDITLAMBDA, Lambda);
	if (pNMUpDown->iDelta<0)
		Lambda += 0.1f;
	else
	{
		Lambda -= 0.1f;
		if (Lambda<0.0f) Lambda = 0.0f;
	}
	DX.m_bSaveAndValidate = FALSE;
	DDX_Text(&DX, IDC_EDITLAMBDA, Lambda);
	*pResult = 0;
}

void CInputData::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	CFrameWnd* frame = GetParentFrame();
	CDialogBar* dlg = (CDialogBar*)frame->GetControlBar( IDW_ALGORITHM );
	CListBox* listbox = (CListBox*)dlg->GetDlgItem(IDC_ALGORITHM_LIST);
	listbox->SetCurSel(0);
	frame->Invalidate();
	DestroyWindow();
	CDialog::OnClose();
}

void CInputData::OnOK() 
{
	// TODO: Add extra validation here
	CMainFrame* frame = (CMainFrame*)GetParentFrame();
	CDialogBar* dlg = (CDialogBar*)frame->GetControlBar( IDW_ALGORITHM );
	CListBox* listbox = (CListBox*)dlg->GetDlgItem(IDC_ALGORITHM_LIST);
	if (UpdateData())
	{
		frame->UpdateDoc();
		listbox->SetCurSel(2);
		frame->Invalidate();
		DestroyWindow();
	}
	else
	{
		listbox->SetCurSel(1);
		frame->Invalidate();
	}
}

void CInputData::OnCancel() 
{
	// TODO: Add extra cleanup here
	CFrameWnd* frame = GetParentFrame();
	CDialogBar* dlg = (CDialogBar*)frame->GetControlBar( IDW_ALGORITHM );
	CListBox* listbox = (CListBox*)dlg->GetDlgItem(IDC_ALGORITHM_LIST);
	listbox->SetCurSel(0);
	frame->Invalidate();
	DestroyWindow();
}

void CInputData::Ok()
{
	OnOK();
}
