// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "VGK.h"
#include "VGKDoc.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_UPDATE_COMMAND_UI(ID_PREV_BLOCK, OnUpdatePrevBlock)
	ON_COMMAND(ID_PREV_BLOCK, OnPrevBlock)
	ON_COMMAND(ID_NEXT_BLOCK, OnNextBlock)
	ON_UPDATE_COMMAND_UI(ID_NEXT_BLOCK, OnUpdateNextBlock)
	ON_UPDATE_COMMAND_UI(ID_INPUTDATA, OnUpdateInputData)
	ON_COMMAND(ID_INPUTDATA, OnInputData)
	ON_UPDATE_COMMAND_UI(ID_OUTPUTDATA, OnUpdateOutputData)
	ON_COMMAND(ID_OUTPUTDATA, OnOutputData)
	//}}AFX_MSG_MAP
	// Global help commands
	ON_UPDATE_COMMAND_UI(ID_VIEW_ALGORITHM, CFrameWnd::OnUpdateControlBarMenu)
	ON_COMMAND_EX(ID_VIEW_ALGORITHM, CFrameWnd::OnBarCheck)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR   // status line indicator
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class
	cs.style &= ~FWS_ADDTOTITLE;
	return CFrameWnd::PreCreateWindow(cs);
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("   \n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("   \n");
		return -1;      // fail to create
	}

    // TODO: Remove this if you don't want tool tips or
	// a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
	m_wndToolBar.SetWindowText(" ");

	// TODO: Delete these three lines if you don't want the toolbar to
	// be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	if (!m_wndDialogBar.Create(this, IDD_ALGORITHM_TOOLBAR,
		                       CBRS_LEFT, IDW_ALGORITHM))
	{
		TRACE0("    \n");
		return -1;      // fail to create
	}
	m_wndDialogBar.SetWindowText("");
	m_wndDialogBar.EnableDocking(CBRS_ALIGN_LEFT|CBRS_ALIGN_RIGHT);
	DockControlBar(&m_wndDialogBar);

	if (!m_wndAlgorithmList.Create(&m_wndDialogBar,IDC_ALGORITHM_LIST))
	{
		TRACE0("    \n");
		return -1;      // fail to create
	}

	RecalcLayout(TRUE);
	LoadBarState(AfxGetApp()->m_pszProfileName);

	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::RecalcLayout(BOOL bNotify) 
{
	// TODO: Add your specialized code here and/or call the base class
	CRect r;
	CSize s;
	GetClientRect(&r);
	r.bottom = r.Height();
	if ((m_wndStatusBar.GetSafeHwnd()!=NULL)&&!m_wndDialogBar.IsFloating())
	{
		if (m_wndStatusBar.IsVisible()) {
			s = m_wndStatusBar.CalcFixedLayout(FALSE,TRUE);
			r.bottom -= s.cy;
			m_wndDialogBar.m_sizeDefault.cy = r.bottom;
		} 
		else
			m_wndDialogBar.m_sizeDefault.cy = r.bottom;
		m_wndAlgorithmList.Resize(&m_wndDialogBar.m_sizeDefault);
	}
	if (m_wndToolBar.GetSafeHwnd()!=NULL)
		if ( m_wndToolBar.IsVisible()&&
			 !m_wndToolBar.IsFloating()&&
			 !m_wndDialogBar.IsFloating()&&
			 ((m_wndToolBar.m_dwStyle&CBRS_ALIGN_TOP)||
			  (m_wndToolBar.m_dwStyle&CBRS_ALIGN_BOTTOM)) )
		{
			s = m_wndToolBar.CalcFixedLayout(FALSE,TRUE);
			r.bottom -= s.cy-m_wndToolBar.m_cxDefaultGap;
			m_wndDialogBar.m_sizeDefault.cy = r.bottom;
			m_wndAlgorithmList.Resize(&m_wndDialogBar.m_sizeDefault);
		}

	CFrameWnd::RecalcLayout(bNotify);
}

BOOL CMainFrame::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	SaveBarState( AfxGetApp()->m_pszProfileName );
	return CFrameWnd::DestroyWindow();
}

void CMainFrame::OnUpdatePrevBlock(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(m_wndAlgorithmList.GetCurSel() > 0);
}

void CMainFrame::OnPrevBlock() 
{
	// TODO: Add your command handler code here
	int cursel = m_wndAlgorithmList.GetCurSel();
	if (cursel == 2) OnInputData();
	else
	{
		if (m_wndOutputData.GetSafeHwnd()!=NULL)
			m_wndOutputData.DestroyWindow();
		if (m_wndInputData.GetSafeHwnd()!=NULL)
			if (cursel<=1)
				m_wndInputData.DestroyWindow();
			else
				m_wndInputData.Ok();
		if (m_wndInputData.GetSafeHwnd()==NULL)
			m_wndAlgorithmList.SetCurSel(cursel-1);
		else
			m_wndAlgorithmList.SetCurSel(1);
		Invalidate();
	}
}

void CMainFrame::OnUpdateNextBlock(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(m_wndAlgorithmList.GetCurSel() < m_wndAlgorithmList.GetCount( )-1);
}

void CMainFrame::OnNextBlock() 
{
	// TODO: Add your command handler code here
	int cursel = m_wndAlgorithmList.GetCurSel();
	if (cursel == 0) OnInputData();
	else
	{
		if (cursel == (m_wndAlgorithmList.GetCount()-2))
			OnOutputData();
		else
		{
			if (m_wndOutputData.GetSafeHwnd()!=NULL)
				m_wndOutputData.DestroyWindow();
			if (m_wndInputData.GetSafeHwnd()!=NULL)
				if (cursel<1)
					m_wndInputData.DestroyWindow();
				else
					m_wndInputData.Ok();
			if (m_wndInputData.GetSafeHwnd()==NULL)
				m_wndAlgorithmList.SetCurSel(cursel+1);
			else
				m_wndAlgorithmList.SetCurSel(1);
			Invalidate();
		}
	}
}


BOOL CMainFrame::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	if (LOWORD(wParam)==IDC_ALGORITHM_LIST)
		if (HIWORD(wParam)==LBN_SELCHANGE)
		{
			int cursel = m_wndAlgorithmList.GetCurSel();
			if (cursel == 1) OnInputData();
			else
			{
				if (cursel == (m_wndAlgorithmList.GetCount()-1))
					OnOutputData();
				else
				{
					if (m_wndOutputData.GetSafeHwnd()!=NULL)
						m_wndOutputData.DestroyWindow();
					if (m_wndInputData.GetSafeHwnd()!=NULL)
						if (cursel<1)
							m_wndInputData.DestroyWindow();
						else
							m_wndInputData.Ok();
					if (m_wndInputData.GetSafeHwnd()==NULL)
						m_wndAlgorithmList.SetCurSel(cursel);
					else
						m_wndAlgorithmList.SetCurSel(1);
					Invalidate();
				}
			}
		}
	return CFrameWnd::OnCommand(wParam, lParam);
}

void CMainFrame::OnUpdateInputData(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(m_wndInputData.GetSafeHwnd()==NULL);
}

void CMainFrame::OnInputData() 
{
	// TODO: Add your command handler code here
	if (m_wndInputData.GetSafeHwnd() == NULL)
	{
		if (m_wndOutputData.GetSafeHwnd() != NULL)
			m_wndOutputData.Close();
		m_wndInputData.Create(CInputData::IDD,this);
		m_wndAlgorithmList.SetCurSel(1);
		Invalidate();
	}
}

void CMainFrame::OnUpdateOutputData(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(m_wndOutputData.GetSafeHwnd()==NULL);
}

void CMainFrame::OnOutputData() 
{
	// TODO: Add your command handler code here
	BOOL bSuccess = FALSE;
	if (m_wndOutputData.GetSafeHwnd() == NULL)
	{
		if (m_wndInputData.GetSafeHwnd() != NULL)
		{
			m_wndInputData.Ok();
			if (m_wndInputData.GetSafeHwnd() != NULL)
				m_wndAlgorithmList.SetCurSel(1);
			else bSuccess = TRUE;
		} 
		else bSuccess = TRUE;
		if (bSuccess)
		{
			m_wndAlgorithmList.SetCurSel(m_wndAlgorithmList.GetCount()-1);
			m_wndOutputData.Create(COutputData::IDD,this);
		}
		Invalidate();
	}
}

void CMainFrame::UpdateDoc()
{
	CVGKDoc* pDoc;
	pDoc = (CVGKDoc*) GetActiveDocument( );
	pDoc->m_L =      m_wndInputData.m_L;
	pDoc->m_T =      m_wndInputData.m_T;
	pDoc->m_Q =      m_wndInputData.m_Q;
	pDoc->m_Nmax =   m_wndInputData.m_Nmax;
	pDoc->m_Nmin =   m_wndInputData.m_Nmin;
	pDoc->m_I =      m_wndInputData.m_I;
	pDoc->m_D0 =     m_wndInputData.m_D0;
	pDoc->m_R2 =     m_wndInputData.m_R2;
	pDoc->m_Lambda = m_wndInputData.m_Lambda;
}
