// MainFrm.h : interface of the CMainFrame class
//
#include "AlgorithmList.h"
#include "InputData.h"
#include "OutputData.h"
/////////////////////////////////////////////////////////////////////////////

class CMainFrame : public CFrameWnd
{
protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:
	void UpdateDoc();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual void RecalcLayout(BOOL bNotify = TRUE);
	virtual BOOL DestroyWindow();
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar     m_wndStatusBar;
	CToolBar       m_wndToolBar;
	CDialogBar     m_wndDialogBar;
	CAlgorithmList m_wndAlgorithmList;
	CInputData     m_wndInputData;
	COutputData    m_wndOutputData;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnUpdatePrevBlock(CCmdUI* pCmdUI);
	afx_msg void OnPrevBlock();
	afx_msg void OnNextBlock();
	afx_msg void OnUpdateNextBlock(CCmdUI* pCmdUI);
	afx_msg void OnUpdateInputData(CCmdUI* pCmdUI);
	afx_msg void OnInputData();
	afx_msg void OnUpdateOutputData(CCmdUI* pCmdUI);
	afx_msg void OnOutputData();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
