// VGKView.cpp : implementation of the CVGKView class
//

#include "stdafx.h"
#include "VGK.h"

#include "VGKDoc.h"
#include "VGKView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
LPCTSTR descript[]=
{
	"         .",
	"      .",
	"    d1,   a,  r1.",
	"        zi       z.",
	"     d.",
	" .            -     -.           [P]     [Q].",
	"     [P]  [Q].",
	"       n  ( ).",
	"      K.",
	"     K.",
	" :  K<=1,       ,       .",
	"        .",
	"        .",
	"         .",
	"       [P]  [Q].",
	"          .",
	"        .",
	"        .",
	"     z.",
	"              Q,      ,    .",
	"              Q,      ,    .",
	"           .",
	"         .",
	"      .",
	"         .",
	"         [P]min.",
	"         [P]max.",
	"       [Q]min.",
	"       [Q]max.",
	"     [Q]min  [Q]max.",
	"     [P]min  [P]max.",
	"               .",
	"               .",
	"              .",
	"             .",
	"             .",
	"              .",
	"     z.",
	"              Q.",
	"              Q.",
	"           .",
	"      .",
	"      .",
	"    Q1.",
	"    P1.",
	"    P2.",
	"        .",
	"      .",
	"        .",
	"    ,       .",
	"    ,       .",
	"        ,       .",
	"          .",
	"          .",
	"              .",
	"  ."
};
/////////////////////////////////////////////////////////////////////////////
// CVGKView

IMPLEMENT_DYNCREATE(CVGKView, CView)

BEGIN_MESSAGE_MAP(CVGKView, CView)
	//{{AFX_MSG_MAP(CVGKView)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVGKView construction/destruction

CVGKView::CVGKView()
{
	// TODO: add construction code here

}

CVGKView::~CVGKView()
{
}

BOOL CVGKView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CVGKView drawing

void CVGKView::OnDraw(CDC* pDC)
{
	CVGKDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	BOOL bSuccess = pDoc->Calculate();
	// TODO: add draw code for native data here
	if (!pDC->IsPrinting())
	{
		pDC->SelectStockObject(ANSI_VAR_FONT);

		CFrameWnd* frame = GetParentFrame();
		CDialogBar* dlg = (CDialogBar*)frame->GetControlBar( IDW_ALGORITHM );
		CListBox* listbox = (CListBox*)dlg->GetDlgItem(IDC_ALGORITHM_LIST);
		int cursel = listbox->GetCurSel();
		CRect r;
		GetClientRect(&r);
		r.left = r.top = 5;
		r.right -= 5; r.bottom -= 5;
		pDC->SetTextColor(RGB(0,0,200));
		r.top = DisplayByWords(pDC,&r,&(CString)descript[cursel]);
		int indexout1 = -1;
		int indexout2 = -1;
		if (bSuccess)
		{
			switch (cursel+1)
			{
				case  7: indexout1 =  0; indexout2 =  1; break;
				case 10: indexout1 =  2; break;
				case 15: indexout1 =  3; indexout2 =  4; break;
				case 18: indexout1 =  5; break;
				case 22: indexout1 = 15; indexout2 = 16; break;
				case 24: indexout1 = 19; break;
				case 30: indexout1 =  7; indexout2 =  8; break;
				case 31: indexout1 =  9; indexout2 = 10; break;
				case 34: indexout1 = 11; indexout2 = 12; break;
				case 37: indexout1 = 13; indexout2 = 14; break;
				case 41: indexout1 = 17; indexout2 = 18; break;
				case 42: indexout1 = 19; break;
				case 49: indexout1 =  6; break;
				case 52: indexout1 = 20; indexout2 = 21; break;
				case 55: indexout1 = 22; indexout2 = 23; break;
			}
			CString t;
			pDC->SetTextColor(RGB(0,100,0));
			if (indexout1>=0)
			{
				t = pDoc->GetOutputStr(indexout1);
				t = t.Left(t.Find("\t"))+" = "+t.Right(t.GetLength()-t.Find("\t")-1);
				r.top = DisplayByWords(pDC,&r,&t);
			}
			if (indexout2>=0)
			{
				t = pDoc->GetOutputStr(indexout2);
				t = t.Left(t.Find("\t"))+" = "+t.Right(t.GetLength()-t.Find("\t")-1);
				r.top = DisplayByWords(pDC,&r,&t);
			}
			if (cursel == 10)
				if (pDoc->m_K>1.0f)
					r.top = DisplayByWords(pDC,&r,&CString("  ()"));
				else
					r.top = DisplayByWords(pDC,&r,&CString("  ()"));
		}
		switch (cursel+1)
		{
			case 1: {
				CRect rect = r;
				r.right /= 2;
				bitmap.LoadRis(1);
				bitmap.DrawBitmap(pDC,&r);
				r.left = rect.right/2; r.bottom = rect.bottom;
				r.right = rect.right;
				bitmap.LoadRis(3);
				bitmap.DrawBitmap(pDC,&r);
			}
				break;
			case 2:	
			case 3:
			case 4:
			case 5:
				bitmap.LoadRis(14);
				bitmap.DrawBitmap(pDC,&r);
				break;
			case 6:
				bitmap.LoadRis(15);
				bitmap.DrawBitmap(pDC,&r);
				break;
			case 16:
			case 17:{
				CRect rect = r;
				r.right /= 2;
				bitmap.LoadRis(20);
				bitmap.DrawBitmap(pDC,&r);
				r.left = rect.right/2; r.bottom = rect.bottom;
				r.right = rect.right;
				bitmap.LoadRis(21);
				bitmap.DrawBitmap(pDC,&r);
			}
				break;
			case 19:
			case 38:
				bitmap.LoadRis(18);
				bitmap.DrawBitmap(pDC,&r);
				break;
			case 26:
			case 27:
			case 28:
			case 29: {
				CRect rect = r;
				r.right /= 2;
				bitmap.LoadRis(16);
				bitmap.DrawBitmap(pDC,&r);
				r.left = rect.right/2; r.bottom = rect.bottom;
				r.right = rect.right;
				bitmap.LoadRis(17);
				bitmap.DrawBitmap(pDC,&r);
			}
				break;
			case 32:
			case 33:
				bitmap.LoadRis(19);
				bitmap.DrawBitmap(pDC,&r);
				break;
			case 43:
			case 44:
			case 45:
			case 46:
				bitmap.LoadRis(17);
				bitmap.DrawBitmap(pDC,&r);
				break;
			case 47:
			case 48: {
				CRect rect = r;
				r.right /= 2;
				bitmap.LoadRis(22);
				bitmap.DrawBitmap(pDC,&r);
				r.left = rect.right/2; r.bottom = rect.bottom;
				r.right = rect.right;
				bitmap.LoadRis(23);
				bitmap.DrawBitmap(pDC,&r);
			}
				break;
			case 50:
			case 51:
				bitmap.LoadRis(26);
				bitmap.DrawBitmap(pDC,&r);
				break;
		}
	}
	else if (bSuccess)
	{
		CFont f;
		if (!f.CreateFont(16,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,
			ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
			DEFAULT_QUALITY,VARIABLE_PITCH|FF_SWISS,"Arial Cyr"))
			pDC->SelectStockObject(SYSTEM_FONT);
		else
			pDC->SelectObject(&f);
		pDC->SetMapMode(MM_LOENGLISH);
		const LPCTSTR title = " - ";
		const LPCTSTR result = " ";
		const LPCTSTR inData[]=
		{
			" ",
			"  L",
			"  t",
			"   Q",
			"    nmax",
			"    nmin",
			"  i",
			"  d0",
			"   r2",
			"    lambda"
		};
		int maxcx = 0;
		CSize s;
		CString str[9];
		int marginx = 30;
		int marginy = 50;
		int widthoflist = pDC->GetDeviceCaps(HORZRES)/pDC->GetDeviceCaps(LOGPIXELSX)*100;
		pDC->SetTextAlign(TA_CENTER);
		pDC->TextOut(widthoflist/2,-marginy,CString(title));
		pDC->SetTextAlign(TA_LEFT);
		marginy += pDC->GetTextExtent(CString(title)).cy;
		pDC->SelectStockObject(SYSTEM_FONT);
		f.DeleteObject();
		if (!f.CreateFont(14,0,0,0,FW_NORMAL,FALSE,FALSE,FALSE,
			ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
			DEFAULT_QUALITY,VARIABLE_PITCH|FF_SWISS,"Times"))
			pDC->SelectStockObject(SYSTEM_FONT);
		else
			pDC->SelectObject(&f);
		for (int i=1; i<=9; i++)
		{
			s = pDC->GetTextExtent(inData[i]);
			if (s.cx>maxcx) maxcx = s.cx;
		}
		int tabstop[] = {maxcx+50};
		int curpos = -(marginy+15+pDC->GetTextExtent(CString(inData[0])).cy);
		maxcx = 0;
		for (i=1; i<=9; i++)
		{
			switch (i)
			{
				case 1:	str[0].Format("%s\t%.1f ",inData[i],pDoc->m_L); break;
				case 2:	str[1].Format("%s\t%.2f ",inData[i],pDoc->m_T); break;
				case 3:	str[2].Format("%s\t%.1f ",inData[i],pDoc->m_Q); break;
				case 4:	str[3].Format("%s\t%.1f /",inData[i],pDoc->m_Nmax); break;
				case 5:	str[4].Format("%s\t%.1f /",inData[i],pDoc->m_Nmin); break;
				case 6:	str[5].Format("%s\t%d",inData[i],pDoc->m_I); break;
				case 7:	str[6].Format("%s\t%.1f ",inData[i],pDoc->m_D0);	break;
				case 8:	str[7].Format("%s\t%.2f ",inData[i],pDoc->m_R2);	break;
				case 9:	str[8].Format("%s\t%.2f",inData[i],pDoc->m_Lambda); break;
			}
			s = pDC->GetTabbedTextExtent(str[i-1],1,&tabstop[0]);
			if (s.cx>maxcx) maxcx = s.cx;
		}
		marginx = (widthoflist - maxcx)/2;
		for (i=1; i<=9; i++)
		{
			s = pDC->TabbedTextOut(marginx,curpos,str[i-1],1,&tabstop[0],marginx);
			curpos -= s.cy;
		}
		marginy += 10;
		pDC->SetTextAlign(TA_CENTER);
		pDC->TextOut(widthoflist/2,-marginy,CString(inData[0]));
		marginx -= 3; maxcx += 6;
		pDC->MoveTo(marginx,-marginy);
		pDC->LineTo(marginx+maxcx,-marginy);
		marginy += pDC->GetTextExtent(CString(inData[0])).cy+3;
		pDC->MoveTo(marginx,-marginy);
		pDC->LineTo(marginx+maxcx,-marginy);
		curpos -= 3;
		pDC->MoveTo(marginx,curpos);
		pDC->LineTo(marginx+maxcx,curpos);

		curpos -= 10; marginy = -curpos;
		pDC->TextOut(widthoflist/2,curpos,CString(result));
		curpos -= pDC->GetTextExtent(CString(result)).cy+5;
		pDC->SetTextAlign(TA_LEFT);
		maxcx = 0;
		for (i=0;i<=23;i++)
		{
			s = pDC->GetTextExtent(CString(outData[i]));
			if (s.cx > maxcx) maxcx = s.cx;
		}
		int tabstops[]={maxcx+50};
		maxcx = 0;
		for (i=0;i<=23;i++)
		{
			s = pDC->GetTabbedTextExtent(pDoc->GetOutputStr(i),1,&tabstops[0]);
			if (s.cx > maxcx) maxcx = s.cx;
		}
		marginx = (widthoflist - maxcx)/2;
		for (i=0;i<=23;i++)
		{
			s = pDC->TabbedTextOut(marginx,curpos,pDoc->GetOutputStr(i),1,&tabstops[0],marginx);
			curpos -= s.cy;
		}
		marginx -= 3; maxcx += 6;
		pDC->MoveTo(marginx,-marginy);
		pDC->LineTo(marginx+maxcx,-marginy);
		marginy += pDC->GetTextExtent(CString(result)).cy+3;
		pDC->MoveTo(marginx,-marginy);
		pDC->LineTo(marginx+maxcx,-marginy);
		curpos -= 3;
		pDC->MoveTo(marginx,curpos);
		pDC->LineTo(marginx+maxcx,curpos);

		pDC->SelectStockObject(SYSTEM_FONT);
		f.DeleteObject();
	}
}

/////////////////////////////////////////////////////////////////////////////
// CVGKView printing

BOOL CVGKView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CVGKView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CVGKView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CVGKView diagnostics

#ifdef _DEBUG
void CVGKView::AssertValid() const
{
	CView::AssertValid();
}

void CVGKView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CVGKDoc* CVGKView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CVGKDoc)));
	return (CVGKDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CVGKView message handlers

int CVGKView::DisplayByWords(CDC* pDC, CRect* rect, CString* str)
{
	CString Temp, NextWord;
	const char EndWord[] = " .,;:!?"; //,   
	int stop, lineHeight,windowWidth;
	TEXTMETRIC tm;
	CSize wordWidth;
	CPoint here;
	
	//    
	pDC->GetTextMetrics(&tm);
	lineHeight = tm.tmHeight + tm.tmExternalLeading;
	//   
	windowWidth = rect->Width();
	//   
	here.x = rect->left;
	here.y = rect->top;

	Temp = *str;
	//        .
	stop = Temp.FindOneOf(EndWord)+1;
	NextWord = Temp.Left(stop);
	//      .
	for (; NextWord != "";)
	{
		//       ?  ,  
		//       .
		if (NextWord.Find("\n")!=-1)
		{
			NextWord = NextWord.Left(NextWord.GetLength()-1);
			here.x = rect->left;
			here.y+=lineHeight;
		}
		//     
		wordWidth = pDC->GetTextExtent(NextWord/*,NextWord.GetLength()*/);
		//   ?  ,    .
		if ((wordWidth.cx+here.x)>windowWidth)
		{
			here.x = rect->left;
			here.y += lineHeight;
		}
		pDC->TextOut(here.x,here.y,NextWord);
		here.x += wordWidth.cx;
		Temp = Temp.Right(Temp.GetLength()-stop);
		stop = Temp.FindOneOf(EndWord)+1;
		if ((stop == 0)&&(Temp!=""))
		{
			NextWord = Temp;
			Temp = "";
		}
		else NextWord = Temp.Left(stop);
	}
	return here.y+lineHeight;
}
